/*
	Phoenix Suite 2
	Author: Jean-Baptiste Wautier
	Copyright 2006-2009 (c)
*/
﻿namespace Phoenix.Log.Writer
{
    using System;

    /// <summary>
    /// Provides instanciation features for Logger
    /// </summary>
    public interface IConfigurator
    {
        #region Methods

        /// <summary>
        /// Adds the specified appender to the appenders' list.
        /// </summary>
        /// <param name="appender">The appender.</param>
        void AddAppender(IAppender appender);

        /// <summary>
        /// Gets an instance of the appender. This appender is configured from the sqliteConfig textWriter
        /// </summary>
        /// <param name="typeOfSender">The type of sender.</param>
        /// <returns>An instance of assembly appender</returns>
        ILogger GetLogger(Type typeOfSender);

        /// <summary>
        /// Removes all the appenders of the specified type.
        /// </summary>
        /// <param name="typeOfAppender">The type of appender.</param>
        void RemoveAppender(System.Type typeOfAppender);

        /// <summary>
        /// Removes the specified appener from the appenders' list.
        /// </summary>
        /// <param name="appender">The appender.</param>
        void RemoveAppener(IAppender appender);

        #endregion Methods
    }
}